	ORG $2000

DRKMSK=$4E
COLRSH=$4F

SDMCTL=$022F	
GPRIOR=$026F
PCOLR0=$02C0
COLOR0=$02C4
CHBAS =$02F4
HPOSP0=$D000
SIZEP0=$D008
GRAFP0=$D00D
COLPF0=$D012
GRACTL=$D01D
DMACTL=$D400
PMBASE=$D407
WSYNC =$D40A
VCOUNT=$D40B

PmArea = $2800

ScrnPtr = $D0
MapPtr = $D2
xpos = $D4
ypos = $D5
pass = $D6
image = $D7

init:
	LDA #255 ; force wrap
	STA pass
	LDA #$2A ; PM DMA
	STA SDMCTL
	STA DMACTL
	LDA #$21 ; (PMs, PFs, Bkg) - 'OR' PM colours
	STA GPRIOR
	LDA #2
	STA GRACTL ; Players only, no Missiles
	LDY #3
@0:	LDA #0 ; single width
	STA SIZEP0,Y
	DEY
	BPL @0
	LDA #>PmArea
	STA PMBASE
	LDA #>Font
	STA CHBAS
	 ; clear player data
	LDA #0
	STA GRAFP0
	STA GRAFP0+2
	STA GRAFP0+1
	STA GRAFP0+3
	; move players on-screen
	LDA #$58
	STA HPOSP0
	STA HPOSP0+1
	LDA #$60
	STA HPOSP0+2
	STA HPOSP0+3
	; set vbi restored colours
	LDA #0 ; black
	STA PCOLR0
	STA PCOLR0+1
	STA PCOLR0+2
	STA PCOLR0+3
	LDA #$C2 ; dark-green
	STA COLOR0+0
	LDA #$C4 ; mid-green
	STA COLOR0+1
	LDA #$CA ; light-green
	STA COLOR0+2
	LDA #$0E ; white (unused)
	STA COLOR0+3
	LDA #0 ;  black (background)
	STA COLOR0+4
	; Setup display
	LDY #<dlist
	LDX #>dlist
	STY SDMCTL+1
	STX SDMCTL+2
	; expand character map data to screen memory
	LDA #0
	STA xpos
	STA ypos
	STA image
	LDX #>ScrnMap
	LDY #<ScrnMap
	STX MapPtr+1
	STY MapPtr
s1:	; y * (40*8) = y*320 = y*(256+64)
	LDA #0
	STA ScrnPtr ; * 256
	LDA ypos
	LSR ; A
	ROR ScrnPtr ; * 128
	LSR ; A
	ROR ScrnPtr ; * 64
	ADC ypos
	STA ScrnPtr+1 ; * 320
	; Add xpos
	LDA xpos
	ADC ScrnPtr
	STA ScrnPtr
	BCC s3
	INC ScrnPtr+1
	CLC
s3:	LDA #<ScrnMem
	ADC ScrnPtr
	STA ScrnPtr
	LDA #>ScrnMem
	ADC ScrnPtr+1
	STA ScrnPtr+1
	; Get next character
	LDY #0
	LDA (MapPtr),Y
	ASL ; A
	ASL ; A
	ASL ; A
	TAX ; offset into Font
	LDA #8
	STA pass
s4:	LDA Font,X
	INX
	STA (ScrnPtr),Y
	LDA #40
	CLC
	ADC ScrnPtr
	STA ScrnPtr
	BCC s5
	INC ScrnPtr+1
s5:	DEC pass
	BNE s4
	; move right
	INC MapPtr
	BNE s6
	INC MapPtr+1
s6:	INC xpos
	LDA xpos
	CMP #40
	BNE s1
	LDA #0
	STA xpos
	INC ypos
	LDA ypos
	CMP #12
	BCC s1
	; and clear players
	LDA #0
	STA image
@fill:
	STA PmArea+$200,Y
	STA PmArea+$300,Y
	INY
	BNE @fill
	JSR PrepareImage
	JMP kernel

PrepareImage:
	LDY image
	LDA ImagesLo,Y
	STA ScrnPtr
	LDA ImagesHi,Y
	STA ScrnPtr+1
	LDY #0
	LDA (ScrnPtr),Y
	STA @CopyA+1
	INY
	LDA (ScrnPtr),Y
	STA @CopyA+2
	INY
	LDA (ScrnPtr),Y
	STA @CopyA+7
	INY
	LDA (ScrnPtr),Y
	STA @CopyA+8
	INY
	LDA (ScrnPtr),Y
	STA @CopyA+13
	INY
	LDA (ScrnPtr),Y
	STA @CopyA+14
	INY
	LDA (ScrnPtr),Y
	STA @CopyA+19
	INY
	LDA (ScrnPtr),Y
	STA @CopyA+20
	INY
	LDA (ScrnPtr),Y
	STA @CopyB+1
	INY
	LDA (ScrnPtr),Y
	STA @CopyB+2
	INY
	LDA (ScrnPtr),Y
	STA @CopyB+7
	INY
	LDA (ScrnPtr),Y
	STA @CopyB+8
	INY
	LDA (ScrnPtr),Y
	STA @CopyB+13
	INY
	LDA (ScrnPtr),Y
	STA @CopyB+14
	INY
	LDA (ScrnPtr),Y
	STA @CopyB+19
	INY
	LDA (ScrnPtr),Y
	STA @CopyB+20
	INY
	LDA (ScrnPtr),Y
	STA @CopyM+5
	INY
	LDA (ScrnPtr),Y
	STA @CopyM+6
	INY
	LDA (ScrnPtr),Y
	STA @CopyM+13
	INY
	LDA (ScrnPtr),Y
	STA @CopyM+14
	INY
	LDA (ScrnPtr),Y
	STA @CopyM+21
	INY
	LDA (ScrnPtr),Y
	STA @CopyM+22
	INY
	LDA (ScrnPtr),Y
	STA @CopyM+29
	INY
	LDA (ScrnPtr),Y
	STA @CopyM+30
	; overlay background color for the PM
	; copy PM data
	LDY #<(ScrnMem+40*40+10)
	LDX #>(ScrnMem+40*40+10)
	STY ScrnPtr
	STX ScrnPtr+1
	LDX #0
@copyM:
	LDY #0
	LDA #$95
	AND img_5_1_L0m,X
	STA (ScrnPtr),Y
	INY
	LDA #$95
	AND img_5_1_L1m,X
	STA (ScrnPtr),Y
	INY
	LDA #$95
	AND img_5_1_R0m,X
	STA (ScrnPtr),Y
	INY
	LDA #$95
	AND img_5_1_R1m,X
	STA (ScrnPtr),Y
	CLC
	LDA #40
	ADC ScrnPtr
	STA ScrnPtr
	LDA #0
	ADC ScrnPtr+1
	STA ScrnPtr+1
	INX
	CPX #32
	BCC @copyM
	RTS
		
kernel:
	INC pass
	LDA pass
	AND #1
	STA pass
@1:	LDA VCOUNT
	CMP #120
	BCC @1
	LDA $14
	BNE @2
	JSR PrepareImage
	INC image
	LDA image
	SEC
	SBC #76
	BNE @2
	STA image
@2:	LDA VCOUNT
	CMP #32
	BCS @2
@3:	LDA VCOUNT
	CMP #32
	BCC @3
	; set player colours
	LDA pass
	BNE pass_1
pass0:
	LDA #$86 ; blue
	AND DRKMSK
	EOR COLRSH
	STA COLPF0
	STA COLPF0+2
	LDA #$1A ; tan
	AND DRKMSK
	EOR COLRSH
	STA COLPF0+1
	STA COLPF0+3
	; copy PM data
	LDY #31
@copyA:
	LDA img_5_1_L0a,Y
	STA PmArea+$238,Y
	LDA img_5_1_L1a,Y
	STA PmArea+$2B8,Y
	LDA img_5_1_R0a,Y
	STA PmArea+$338,Y
	LDA img_5_1_R1a,Y
	STA PmArea+$3B8,Y
	DEY
	BPL @copyA
	JMP kernel
pass_1:
	LDX #$02 ; black
	LDY #$0E ; white
	STX COLPF0
	STY COLPF0+1
	STX COLPF0+2
	STY COLPF0+3
	; copy PM data
	LDY #31
@copyB:
	LDA img_5_1_L0b,Y
	STA PmArea+$238,Y
	LDA img_5_1_L1b,Y
	STA PmArea+$2B8,Y
	LDA img_5_1_R0b,Y
	STA PmArea+$338,Y
	LDA img_5_1_R1b,Y
	STA PmArea+$3B8,Y
	DEY
	BPL @copyB
	JMP kernel

	ORG PmArea
ScrnMem=PmArea+$800
dlist:
:3	.byte $70
	.byte $4D
	.word ScrnMem
:95	.byte $0D
	.byte $41
	.word dlist

	ORG PmArea+$400
Font:
	ins 'area2_test.fnt'

	ORG PmArea+$500
ScrnMap:
	ins 'area2_test.scr'

	ORG $4000
	icl 'pm_data.asm'

	run init